package com.ruoyi.web.base.controller;


import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.framework.web.service.TokenService;
import com.ruoyi.web.base.domain.BaseVariety;
import com.ruoyi.web.base.service.IBaseVarietyService;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.Map;

import static com.ruoyi.common.core.domain.AjaxResult.success;
import static com.ruoyi.common.utils.SecurityUtils.getUsername;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author author
 * @since 2026-02-02
 */
@RestController
@RequestMapping("/base-variety")
public class BaseVarietyController {
    @Autowired
    private IBaseVarietyService baseVarietyService;
    @Autowired
    private TokenService tokenService;

    @ApiOperation("品种管理添加")
    @PostMapping("/add")
    public AjaxResult add(@RequestBody BaseVariety baseVariety, HttpServletRequest request) throws Exception {
        String loginOrgId = tokenService.getLoginOrgId(request);
        if (baseVarietyService.count(new QueryWrapper<BaseVariety>().eq("org_id",loginOrgId).eq("variety_no", baseVariety.getVarietyNo())) >0 ){
            throw new Exception("该编号已存在");
        }

        baseVariety.setOrgId(loginOrgId);
        baseVariety.setCreateBy(getUsername());
        return success(baseVarietyService.save(baseVariety));
    }

    @ApiOperation("品种管理修改")
    @PostMapping("/edit")
    public AjaxResult edit(@RequestBody BaseVariety baseVariety, HttpServletRequest request) throws Exception {
        String loginOrgId = tokenService.getLoginOrgId(request);
        if (baseVarietyService.count(new QueryWrapper<BaseVariety>().ne("id",baseVariety.getId()).eq("org_id",loginOrgId).eq("variety_no", baseVariety.getVarietyNo())) >0 ){
            throw new Exception("该编号已存在");
        }
        baseVariety.setUpdateBy(getUsername());
        return success(baseVarietyService.updateById(baseVariety));
    }

    @ApiOperation("品种管理删除")
    @PostMapping("/delete")
    public AjaxResult delete(@RequestBody Map<String, String> paramsMap) {
        String ids = paramsMap.get("ids");
        for (String s : ids.split(",")) {
            baseVarietyService.removeById(s);
        }
        return success();
    }

    @ApiOperation("品种管理列表")
    @PostMapping("/list")
    public AjaxResult listAll( HttpServletRequest request){
        return success(baseVarietyService.list(new QueryWrapper<BaseVariety>().eq("org_id",tokenService.getLoginOrgId(request))));
    }

    @ApiOperation("品种管理分页")
    @GetMapping("/page")
    public AjaxResult page(@RequestParam("pageNum") Integer pageNum, @RequestParam("pageSize") Integer pageSize,HttpServletRequest request
    ) {
        return success(baseVarietyService.page(new Page<BaseVariety>(pageNum,pageSize),new QueryWrapper<BaseVariety>().eq("org_id",tokenService.getLoginOrgId(request))));
    }

    @ApiOperation("品种管理详情")
    @PostMapping("/listById")
    public AjaxResult listById(@RequestBody Map<String, String> paramsMap){
        String id = paramsMap.get("id");
        return success(baseVarietyService.getById(id));
    }

}
